package jpatp.aggregate;

import java.util.List;

import javax.persistence.Query;
import javax.persistence.EntityManager;
import jpa.test.client.*;

/**
 * @author Hiroaki, Chiba
 * 
 */
public class Client extends ClientJPABase
{
    private Query query;

    private EntityManager em;

    public static void main(String args[])
    {

        Client cl = new Client("em1");
        cl.aggreGate011();
        cl.cleanup();
    }

    // contructor
    private Client(String unitname)
    {
        super(unitname);
    }
    /**
     * check ID:aggreGate011
     * 
     * @return
     */
    public boolean aggreGate011()
    {
        testStart("aggreGate011");
        try
        {
            em = getEntityManager();
            transactionBegin();
            Addressaggregate add = new Addressaggregate(100,1,"","A","B","C","D");
            em.persist(add);
            em.merge(add);
            Addressaggregate add2 = new Addressaggregate(101,1,"1","A","B","C","D");
            em.persist(add2);
            em.merge(add);
            Addressaggregate add3 = new Addressaggregate(102,1,"1","A","B","C","D");
            em.persist(add3);
            em.merge(add3);
            transactionCommit();
            // the beginning log of the TP
            // the beginning of the transaction
            transactionBegin();
            // Get the data from DB and initialize the list.
            query = em.createQuery("select DISTINCT SUM(a.VAL) from Addressaggregate a order by a.ID");
            // The compilation warning: To evade no inspection Cast
            List<Addressaggregate> results = Addressaggregates.getList(query.getResultList());
            log("select SUM(a.VAL) from Addressaggregate a order by a.ID result:" + results.get(0));
            detail("select SUM(a.VAL) from Addressaggregate a order by a.ID result:" + results.get(0));
            System.out.println("select SUM(a.VAL) from Addressaggregate a order by a.ID result:" + results.get(0));
            transactionCommit();
        }
        catch (IllegalArgumentException e) {
            detail("### Unexpected exception occured.");
            detail("### " + e.getMessage());
            e.printStackTrace();
            System.out.println(e);
            transactionRollback();
        }
        catch(Throwable th)
        {
            detail("### Unexpected exception occured.");
            detail("### " + th.getMessage());
            failed("Unexpected exception occured.", th);
            System.out.println(th);
            transactionRollback();
        }
        finally
        {
            // the log of TP end
            testEnd();
        }
        return true;
    }


}
